'use strict';











var _fs = require('fs');var _fs2 = _interopRequireDefault(_fs);
var _path = require('path');var _path2 = _interopRequireDefault(_path);
var _jsonlint = require('./vendor/jsonlint');var _jsonlint2 = _interopRequireDefault(_jsonlint);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                               * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                               *
                                                                                                                                                                                               * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                               * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                               * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                               *
                                                                                                                                                                                               * 
                                                                                                                                                                                               */const JEST_CONFIG = 'jest.config.js';const PACKAGE_JSON = 'package.json';const isFile = filePath => _fs2.default.existsSync(filePath) && !_fs2.default.lstatSync(filePath).isDirectory();const findConfig = root => {
  // $FlowFixMe
  let options = {};
  let directory = root;
  const isJS = directory.endsWith('.js');
  if ((isJS || directory.endsWith('.json')) && isFile(directory)) {
    const filePath = _path2.default.resolve(process.cwd(), directory);
    if (isJS) {
      // $FlowFixMe
      options = require(filePath);
    } else {
      let pkg;
      try {
        // $FlowFixMe
        pkg = require(filePath);
      } catch (error) {
        throw new Error(
        `Jest: Failed to parse config file ${filePath}\n` +
        `  ${_jsonlint2.default.errors(_fs2.default.readFileSync(filePath, 'utf8'))}`);

      }
      if (directory.endsWith(PACKAGE_JSON)) {
        options = pkg.jest || options;
      } else {
        options = pkg;
      }
    }
    options.rootDir = options.rootDir ?
    _path2.default.resolve(_path2.default.dirname(directory), options.rootDir) :
    _path2.default.dirname(directory);
    return options;
  }

  do {
    const configJsFilePath = _path2.default.resolve(_path2.default.join(directory, JEST_CONFIG));
    if (isFile(configJsFilePath)) {
      // $FlowFixMe
      options = require(configJsFilePath);
      break;
    }

    const packageJsonFilePath = _path2.default.resolve(
    _path2.default.join(directory, PACKAGE_JSON));

    if (isFile(packageJsonFilePath)) {
      // $FlowFixMe
      const pkg = require(packageJsonFilePath);
      if (pkg.jest) {
        options = pkg.jest;
      }
      // Even if there is no configuration, we stop traveling up the
      // tree if we hit a `package.json` file.
      break;
    }
  } while (directory !== (directory = _path2.default.dirname(directory)));

  options.rootDir = options.rootDir ?
  _path2.default.resolve(root, options.rootDir) :
  _path2.default.resolve(directory);

  return options;
};

module.exports = findConfig;